#include "countdown.h"
#include <interrupt.h>



#include <sys/time.h>
#include <signal.h>
/***************************************************************
* slection  du timer et signal  
***************************************************************/                        




  


/*! \ingroup Gtimer
\brief Initier un dcomptage
\param uS dure de dcomptage en microsecondes
\return le temps restant  dcompter du  dcomptage prcdent ou 0 

\htmlonly <hr WIDTH="100%"> \endhtmlonly 
\htmlonly <hr WIDTH="100%"> \endhtmlonly 
\b Implantation
L'implantation UNIX est trs simple. Il suffit de charger le compteur ITIMER_VIRTUAL avec la valeur donne.
*/


long FredCountDownStart( long uS)
 /* uS en micro secondes */
{ 
	struct itimerval q;struct itimerval old;
	/* dcomptage coup par coup : 
	un dcomptage  la fois et arrt du timer  en fin de dcompte */
	q.it_interval.tv_sec=0;
	q.it_interval.tv_usec=0;
	/* duree du decomptage   */
	q.it_value.tv_sec=0;
	q.it_value.tv_usec = uS ;
	setitimer((int)ITIMER_VIRTUAL,&q,&old);
	return old.it_value.tv_usec;
}




/*! \ingroup Gtimer
\brief Arrter un dcomptage
\return le temps restant  dcompter du  dcomptage prcdent ou 0 

\htmlonly <hr WIDTH="100%"> \endhtmlonly 
\htmlonly <hr WIDTH="100%"> \endhtmlonly 
\b Implantation
L'implantation UNIX est trs simple. Il suffit de charger le compteur ITIMER_VIRTUAL avec la valeur 0 qui l'arrte.
*/
   
long FredCountDownStop()
{ 
	struct itimerval q;struct itimerval old;
	/* dcomptage coup par coup : 
	un dcomptage  la fois et arrt du timer  */
	q.it_interval.tv_sec=0;
	q.it_interval.tv_usec=0;
	/* duree du decomptage   */
	q.it_value.tv_sec=0;
	q.it_value.tv_usec = 0 ;
	setitimer((int)ITIMER_VIRTUAL,&q,&old);
	/* temps restant  dcompter */
	return old.it_value.tv_usec;
}


/*! \ingroup Gtimer
\brief Lecture du dcompteur
\return le temps restant  dcompter du  dcomptage prcdent ou 0 

\htmlonly <hr WIDTH="100%"> \endhtmlonly 
\htmlonly <hr WIDTH="100%"> \endhtmlonly 
\b Implantation
L'implantation UNIX est trs simple. Il suffit de lirer le compteur ITIMER_VIRTUAL .
*/
   
long int  FredCountDownGet()
{ 
	 struct itimerval old;
	getitimer((int)ITIMER_VIRTUAL,&old);
	/* temps restant  dcompter */
	return old.it_value.tv_usec;
}



/*! \ingroup Gtimer
\brief Attache un traitant de fin de dcomptage
 \param handler  code  excuter sur it timer

\htmlonly <hr WIDTH="100%"> \endhtmlonly 
\htmlonly <hr WIDTH="100%"> \endhtmlonly 
\b Implantation
L'implantation UNIX est trs simple. Il suffit d'attacher le traitant au signal SIGVTALRM associ compteur ITIMER_VIRTUAL. 
*/
void FredCountDownAttach(void(*handler)(int))
{ 
	FredSignalAttach(SIGVTALRM,handler);
}

