

#include "list.h"



/*! \ingroup Glist
\brief Insertion en queue d'une cellule 
\param q  liste o insrer
\param b cellule  insrer

\htmlonly <hr WIDTH="100%"> \endhtmlonly 
\htmlonly <hr WIDTH="100%"> \endhtmlonly 
\b Implantation

L'insertion en queue place la nouvelle cellule entre le dernier et le premier. Elle devient le nouveau dernier item. Deux cas particuliers sont la file vide et la file  une cellule (qui est chaine sur elle mme). Ce dernier cas peut se programmer comme le cas gnral.
*/
void FredListPutLast(FredList *q,FredCell *b)
{
	if(FredListEmpty(q)){ 
		/* file vide */
		b->next=b->pred=b;
		q->last=b;
	}else{
    b->next=q->last->next;
		b->pred=q->last;
		b->next->pred=b;
		b->pred->next=b;
		q->last=b;
	}
}



/*! \ingroup Glist
\brief Retrait de la cellule de tte
\param q  liste o  retirer
\result  cellule retirer
\htmlonly <hr WIDTH="100%"> \endhtmlonly 
\htmlonly <hr WIDTH="100%"> \endhtmlonly 
\b Implantation

	Le retrait en tte  ncessite de traiter le cas d'une file vide et le cas d'une file  1 lment. Le cas d'une file  2 cellules qui devient  1 cellule(qui est chaine sur elle mme) peut se traiter comme le cas gnral. 
*/


 FredCell* FredListGetFirst(FredList *q) 
{
	FredCell* b;
	if(FredListEmpty(q)){ 
		/* file vide */
		return NIL;
	}else if ( q->last->next==q->last){
		/* file  1 item */
		b=q->last; 
		q->last=NIL; /* la file devient vide */
	}else {
		b=q->last->next;
		b->pred->next=b->next;
    b->next->pred=b->pred;
	}
  b->next=b->pred=NIL; /* la cellule n'est plus chaine */
	return b;
}





/*! \ingroup Glist
\brief Initialisation de la liste
\param q liste  initialiser

\htmlonly <hr WIDTH="100%"> \endhtmlonly 
\htmlonly <hr WIDTH="100%"> \endhtmlonly 
\b Implantation
*/
 void FredListInit(FredList *q) 
{ 
	q->last=NIL;
}





