/*! \file  mem.h
\brief Inclusion de la gestion mmoire
*/
#ifndef _MEM_H
#define _MEM_H




extern void * FredAtomicAlloc(int);
extern void * FredAtomicCalloc(int,int);
extern void  FredAtomicFree(void *);


/*! \ingroup Gmem
\brief Alloue \b atomiquement un bloc pour un type donn
\param T type  allouer
\return un pointeur sur une valeur du type ou 0
 * 
 * 
L'intrt est de dissimuler les concersions de type et calcul de taille en octets du bloc  allouer.
*/
#define FredNEW(T)  (T*)FredAtomicAlloc(sizeof(T))
/*! \ingroup Gmem
\brief Alloue \b atomiquement un vecteur de blocs pour un type donn
\param T type  allouer
\param CT nombre d'item dans le vecteur
\return un pointeur sur un vecteur du type ou 0
 * 
 *
L'intrt est de dissimuler les conversions de type et calcul de taille en octets du bloc  allouer.

\htmlonly <hr WIDTH="100%"> \endhtmlonly 
\htmlonly <hr WIDTH="100%"> \endhtmlonly 
\b Implantation
  Simple mise en exclusion mutuelle de la procdure quivalente de la lib C.
*/

#define FredNEW_VECTOR(T,CT)  (T*)FredAtomicCalloc(sizeof(T),(CT))

/*! \ingroup Gmem
\brief Libre \b atomiquement un bloc ou un vecteur de blocs prcdemment allou
\param X  bloc  librer
 L'intrt est de dissimuler la conversion de type 

*/
#define FredDELETE(X) FredAtomicFree((void*)X)
#endif
