/*! \file  sema.h
\brief Inclusion des smaphores
*/

#ifndef _SEMA_H
#define _SEMA_H
#include "fred.h"



/*! \ingroup Gsema
\brief Descripteur du smaphore


Un smaphore est dcrit par un compteur et une file d'attente. La valeur initiale du compteur doit  tre >= 0


\htmlonly <hr WIDTH="100%"> \endhtmlonly 
\htmlonly <hr WIDTH="100%"> \endhtmlonly 
\b Implantation
 Le compteur reprsente le nombre de jetons si le compteur est >=0 et le nombre de threads en attente s'il est <0.   

*/
typedef struct FredSemaphore
{ 
	volatile int counter;		/*!< compteur de jeton */
	FredQueue queue;/*!< queue des threads en attente */
} FredSemaphore;

 


extern void        FredSemaphoreInit(FredSemaphore * s, int i );
extern void            FredSemaphoreP( FredSemaphore * s );
extern void            FredSemaphoreV( FredSemaphore  *s );

#endif
